!  PRIMME PReconditioned Iterative MultiMethod Eigensolver
!  Copyright (C) 2005  James R. McCombs,  Andreas Stathopoulos
!  Copyright (C) 2014  Scientific Computing and Modelling NV
!
!  This file is part of PRIMME.
!
!  PRIMME is free software; you can redistribute it and/or
!  modify it under the terms of the GNU Lesser General Public
!  License as published by the Free Software Foundation; either
!  version 2.1 of the License, or (at your option) any later version.
!
!  PRIMME is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with this library; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

module PrimmeDefsModule

   implicit none
   public

!-------------------------------------------------------
!     Defining easy to remember labels for setting the
!     method in primme_set_method from Fortran
!-------------------------------------------------------
   integer, parameter ::                        &
      PRIMMEF77_DYNAMIC                   =  0, &
      PRIMMEF77_DEFAULT_MIN_TIME          =  1, &
      PRIMMEF77_DEFAULT_MIN_MATVECS       =  2, &
      PRIMMEF77_Arnoldi                   =  3, &
      PRIMMEF77_GD                        =  4, &
      PRIMMEF77_GD_plusK                  =  5, &
      PRIMMEF77_GD_Olsen_plusK            =  6, &
      PRIMMEF77_JD_Olsen_plusK            =  7, &
      PRIMMEF77_RQI                       =  8, &
      PRIMMEF77_JDQR                      =  9, &
      PRIMMEF77_JDQMR                     = 10, &
      PRIMMEF77_JDQMR_ETol                = 11, &
      PRIMMEF77_SUBSPACE_ITERATION        = 12, &
      PRIMMEF77_LOBPCG_OrthoBasis         = 13, &
      PRIMMEF77_LOBPCG_OrthoBasis_Window  = 14

!-------------------------------------------------------
!     Defining easy to remember labels for setting the
!     members of the primme structure from Fortran
!-------------------------------------------------------
   integer, parameter ::                                    &
      PRIMMEF77_n                                     =  0, &
      PRIMMEF77_matrixMatvec                          =  1, &
      PRIMMEF77_applyPreconditioner                   =  2, &
      PRIMMEF77_numProcs                              =  3, &
      PRIMMEF77_procID                                =  4, &
      PRIMMEF77_commInfo                              =  5, &
      PRIMMEF77_nLocal                                =  6, &
      PRIMMEF77_globalSumDouble                       =  7, &
      PRIMMEF77_numEvals                              =  8, &
      PRIMMEF77_target                                =  9, &
      PRIMMEF77_numTargetShifts                       = 10, &
      PRIMMEF77_targetShifts                          = 11, &
      PRIMMEF77_locking                               = 12, &
      PRIMMEF77_initSize                              = 13, &
      PRIMMEF77_numOrthoConst                         = 14, &
      PRIMMEF77_maxBasisSize                          = 15, &
      PRIMMEF77_minRestartSize                        = 16, &
      PRIMMEF77_maxBlockSize                          = 17, &
      PRIMMEF77_maxMatvecs                            = 18, &
      PRIMMEF77_maxOuterIterations                    = 19, &
      PRIMMEF77_intWorkSize                           = 20, &
      PRIMMEF77_realWorkSize                          = 21, &
      PRIMMEF77_iseed                                 = 22, &
      PRIMMEF77_intWork                               = 23, &
      PRIMMEF77_realWork                              = 24, &
      PRIMMEF77_aNorm                                 = 25, &
      PRIMMEF77_eps                                   = 26, &
      PRIMMEF77_printLevel                            = 27, &
      PRIMMEF77_outputFile                            = 28, &
      PRIMMEF77_matrix                                = 29, &
      PRIMMEF77_preconditioner                        = 30, &
      PRIMMEF77_restartingParams_scheme               = 31, &
      PRIMMEF77_restartingParams_maxPrevRetain        = 32, &
      PRIMMEF77_correctionParams_precondition         = 33, &
      PRIMMEF77_correctionParams_robustShifts         = 34, &
      PRIMMEF77_correctionParams_maxInnerIterations   = 35, &
      PRIMMEF77_correctionParams_projectors_LeftQ     = 36, &
      PRIMMEF77_correctionParams_projectors_LeftX     = 37, &
      PRIMMEF77_correctionParams_projectors_RightQ    = 38, &
      PRIMMEF77_correctionParams_projectors_RightX    = 39, &
      PRIMMEF77_correctionParams_projectors_SkewQ     = 40, &
      PRIMMEF77_correctionParams_projectors_SkewX     = 41, &
      PRIMMEF77_correctionParams_convTest             = 42, &
      PRIMMEF77_correctionParams_relTolBase           = 43, &
      PRIMMEF77_stats_numOuterIterations              = 44, &
      PRIMMEF77_stats_numRestarts                     = 45, &
      PRIMMEF77_stats_numMatvecs                      = 46, &
      PRIMMEF77_stats_numPreconds                     = 47, &
      PRIMMEF77_stats_elapsedTime                     = 48, &
      PRIMMEF77_dynamicMethodSwitch                   = 49, &
      PRIMMEF77_massMatrixMatvec                      = 50, &
      PRIMMEF77_diagonalize                           = 51

!-------------------------------------------------------
!    Defining easy to remember labels for setting the
!    enum members for targeting, restarting and innertest
!-------------------------------------------------------
   integer, parameter ::                    &
      PRIMMEF77_smallest               = 0, &
      PRIMMEF77_largest                = 1, &
      PRIMMEF77_closest_geq            = 2, &
      PRIMMEF77_closest_leq            = 3, &
      PRIMMEF77_closest_abs            = 4, &
      PRIMMEF77_thick                  = 0, &
      PRIMMEF77_dtr                    = 1, &
      PRIMMEF77_full_LTolerance        = 0, &
      PRIMMEF77_decreasing_LTolerance  = 1, &
      PRIMMEF77_adaptive_ETolerance    = 2, &
      PRIMMEF77_adaptive               = 3

end module
